include \masm32\include\masm32rt.inc

.data
OriginalEditProc DWORD 0


.code
start:

call Main
call ExitProcess

CreateSuperEdit proc hParent:DWORD
LOCAL wc:WNDCLASSEX
LOCAL hinst:HINSTANCE
STRING szEditClass,"EDIT"
STRING szSuperEditClass, "SUPER_EDIT_CLASS"

invoke GetModuleHandle, NULL
mov hinst,eax

mov wc.cbSize, sizeof WNDCLASSEX 
invoke GetClassInfoEx, NULL, ADDR szEditClass, ADDR wc
mov wc.lpszClassName, OFFSET szSuperEditClass
m2m OriginalEditProc, wc.lpfnWndProc
mov wc.lpfnWndProc, OFFSET SuperEditProc
m2m wc.hInstance, hinst
invoke RegisterClassEx, ADDR wc

invoke CreateWindowEx, WS_EX_LEFT, ADDR szSuperEditClass, NULL, WS_TABSTOP or WS_VISIBLE or WS_CHILD, 10, 10, 200, 20, hParent, NULL, hinst, NULL

ret
CreateSuperEdit endp

SuperEditProc proc hwnd:DWORD,msg:DWORD,wparam:DWORD,lparam:DWORD

.IF msg==WM_CHAR
invoke GetWindowTextLength,hwnd
.IF eax==2 && wparam !=8 ; backspace
mov eax,'-'
invoke CallWindowProc,OriginalEditProc,hwnd,msg,eax,lparam
.ENDIF
.ENDIF

invoke CallWindowProc,OriginalEditProc,hwnd,msg,wparam,lparam
ret
SuperEditProc endp


Main proc
LOCAL wc:WNDCLASSEX
LOCAL hinst:HINSTANCE
LOCAL msg:MSG
STRING szWindowClass,"MAIN_WINDOW_CLASS"
STRING szWindowTitle,"Main Window"

invoke GetModuleHandle, NULL
mov hinst,eax

mov wc.cbSize,         sizeof WNDCLASSEX
mov wc.style,          NULL
m2m wc.lpfnWndProc,    OFFSET WndProc
mov wc.cbClsExtra,     NULL
mov wc.cbWndExtra,     NULL
m2m wc.hInstance,      hinst
mov wc.hbrBackground,  1
mov wc.lpszMenuName,   NULL
mov wc.lpszClassName,  OFFSET szWindowClass
mov wc.hIcon,          NULL
invoke LoadCursor,NULL,IDC_ARROW 
mov wc.hCursor,        eax
mov wc.hIconSm,        NULL

invoke RegisterClassEx, ADDR wc
invoke CreateWindowEx, WS_EX_LEFT, ADDR szWindowClass, ADDR szWindowTitle, WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN, 15, 15, 300, 100, NULL, NULL, hinst, NULL
invoke ShowWindow,eax,SW_SHOW

MsgLoop:
invoke GetMessage,ADDR msg,NULL,0,0
test eax,eax
jz MsgLoopOut
invoke TranslateMessage, ADDR msg
invoke DispatchMessage, ADDR msg
jmp MsgLoop
MsgLoopOut:

ret
Main endp

WndProc proc hwnd:DWORD,msg:DWORD,wparam:DWORD,lparam:DWORD

.IF msg == WM_CREATE
invoke CreateSuperEdit,hwnd
.ELSEIF msg == WM_DESTROY
invoke PostQuitMessage,NULL
xor eax,eax
ret
.ENDIF

invoke DefWindowProc,hwnd,msg,wparam,lparam
ret
WndProc endp


end start
